lists.openwall.net   lists  /  announce  owl-users  owl-dev  john-users  john-dev  passwdqc-users  yescrypt  popa3d-users  /  oss-security  kernel-hardening  musl  sabotage  tlsify  passwords  /  crypt-dev  xvendor  /  Bugtraq  Full-Disclosure  linux-kernel  linux-netdev  linux-ext4  linux-hardening  linux-cve-announce  PHC 
Open Source and information security mailing list archives
 
Hash Suite: Windows password security audit tool. GUI, reports in PDF.
[<prev] [next>] [<thread-prev] [thread-next>] [day] [month] [year] [list]
Date:   Tue, 20 Sep 2022 15:15:42 -0700
From:   Namhyung Kim <namhyung@...nel.org>
To:     Leo Yan <leo.yan@...aro.org>
Cc:     Arnaldo Carvalho de Melo <acme@...nel.org>,
        Peter Zijlstra <peterz@...radead.org>,
        Ingo Molnar <mingo@...hat.com>,
        Mark Rutland <mark.rutland@....com>,
        Alexander Shishkin <alexander.shishkin@...ux.intel.com>,
        Jiri Olsa <jolsa@...nel.org>,
        linux-kernel <linux-kernel@...r.kernel.org>,
        linux-perf-users <linux-perf-users@...r.kernel.org>
Subject: Re: [PATCH RESEND v2] perf test: Introduce script for data symbol testing

On Sat, Sep 17, 2022 at 8:28 PM Leo Yan <leo.yan@...aro.org> wrote:
>
> This commit introduces a shell script for data symbol testing.
>
> The testing is designed a data structure with 64-byte alignment, it has
> two fields "data1" and "data2", and other fields are reserved.
>
> Using "perf mem" command, we can record and report memory samples for a
> self-contained workload with 1 second duration.  If have no any memory
> sample for the data structure "buf1", it reports failure;  and by
> checking the offset in structure "buf1", if any memory accessing is not
> for "data1" and "data2" fields, it means wrong data symbol parsing and
> returns failure.
>
> Signed-off-by: Leo Yan <leo.yan@...aro.org>
> ---
>
> Changes from v1:
> - Removed "killall" since the test has no child process (Ian);
> - Used "char" instead of "long" in the buf structure.
>
>  tools/perf/tests/shell/test_data_symbol.sh | 92 ++++++++++++++++++++++
>  1 file changed, 92 insertions(+)
>  create mode 100755 tools/perf/tests/shell/test_data_symbol.sh
>
> diff --git a/tools/perf/tests/shell/test_data_symbol.sh b/tools/perf/tests/shell/test_data_symbol.sh
> new file mode 100755
> index 000000000000..d007513ecfbe
> --- /dev/null
> +++ b/tools/perf/tests/shell/test_data_symbol.sh
> @@ -0,0 +1,92 @@
> +#!/bin/bash
> +# Test data symbol
> +
> +# SPDX-License-Identifier: GPL-2.0
> +# Leo Yan <leo.yan@...aro.org>, 2022
> +
> +skip_if_no_mem_event() {
> +       perf mem record -e list 2>&1 | egrep -q 'available' && return 0
> +       return 2
> +}
> +
> +skip_if_no_mem_event || exit 2
> +
> +# skip if there's no compiler
> +if ! [ -x "$(command -v cc)" ]; then
> +       echo "skip: no compiler, install gcc"
> +       exit 2
> +fi
> +
> +TEST_PROGRAM_SOURCE=$(mktemp /tmp/__perf_test.program.XXXXX.c)
> +TEST_PROGRAM=$(mktemp /tmp/__perf_test.program.XXXXX)
> +PERF_DATA=$(mktemp /tmp/__perf_test.perf.data.XXXXX)
> +
> +check_result() {
> +       # The memory report format is as below:
> +       #    99.92%  ...  [.] buf1+0x38  ...
> +       result=$(perf mem report -i ${PERF_DATA} --stdio 2>&1 | egrep "buf1" | \
> +               awk '{ for (i = 1; i <= NF; i++) { if ($i ~ /^buf1/) { print $i; break; } } }')

It'd be simpler to use the 'symbol_daddr' sort key alone.

  result=$(perf mem report -i ${PERF_DATA} -s symbol_daddr -q 2>&1 | \
        awk '/buf1/ { print $4 }'


> +
> +       # Testing is failed if has no any sample for "buf1"
> +       [ -z "$result" ] && return 1
> +
> +       while IFS= read -r line; do
> +               # The "data1" and "data2" fields in structure "buf1" have
> +               # offset "0x0" and "0x38", returns failure if detect any
> +               # other offset value.
> +               if [ "$line" != "buf1+0x0" ] && [ "$line" != "buf1+0x38" ]; then
> +                       return 1
> +               fi
> +       done <<< "$result"
> +
> +       return 0
> +}
> +
> +cleanup_files()
> +{
> +       echo "Cleaning up files..."
> +       rm -f ${PERF_DATA}
> +       rm -f ${TEST_PROGRAM_SOURCE}
> +       rm -f ${TEST_PROGRAM}
> +}
> +
> +trap cleanup_files exit term int
> +
> +# compile test program
> +cat << EOF > $TEST_PROGRAM_SOURCE

You could directly call the compiler with a pipe.

> +#include <stdio.h>
> +#include <stdlib.h>
> +#include <unistd.h>

The headers are not used?

> +
> +typedef struct _buf {
> +       char data1;
> +       char reserved[55];
> +       char data2;
> +} buf __attribute__((aligned(64)));
> +
> +static buf buf1;
> +
> +int main() {

s/()/(void)/

> +       int i;

unused.

Thanks,
Namhyung


> +       for (;;) {
> +               buf1.data1++;
> +               buf1.data2 += buf1.data1;
> +       }
> +       return 0;
> +}
> +EOF
> +
> +echo "Compiling test program..."
> +cc $TEST_PROGRAM_SOURCE -o $TEST_PROGRAM || exit 1
> +
> +echo "Recording workload..."
> +perf mem record --all-user -o ${PERF_DATA} -- $TEST_PROGRAM &
> +PERFPID=$!
> +
> +sleep 1
> +
> +kill $PERFPID
> +wait $PERFPID
> +
> +check_result
> +exit $?
> --
> 2.34.1
>

Powered by blists - more mailing lists

Powered by Openwall GNU/*/Linux Powered by OpenVZ